## Title: Gnip_Elite
## Author: SirGnip
## License: LGPL (c) 2007 Scott O. Nelson
## Description: Each player has an "Elite" that they can position to power up fleets.

import galcon
import gui

import level
#################### gnip mod
import gniplevel
####################

version = '0.2'

def build_app(game):
    pad = 16
    
    t = gui.Table()
    box = gui.Box(t,width=SW,height=SH,background=galcon.Bkgr())
    app = gui.App(game,box,False)

    t.tr()
    t.td(gui.Box(gui.Label('Gnip_Elite Mod Options',style={'font':galcon.Font(32)}),style={'margin-top':pad}),colspan=2)
    t.tr()
    t.td(gui.Box(gui.Label('(v%s)'%version),style={'margin-bottom':pad}),colspan=2)

    # instructions
    s = {'font':galcon.Font(11)}
    t.tr()
    t.td(gui.Box(gui.Label("Instructions:",style={'font':galcon.Font(16)}),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("In this mod, every player starts with one Elite, as indicated by the three",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("colored rings around one of your planets.  When you launch a fleet from a planet",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("that contains your Elite, the Elite will travel with the fleet (as indicated by",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("the three colored rings that travel with the fleet).  When the Elite fleet",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("attacks an enemy planet, your attack effectiveness is now *doubled*.  If your",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("attack is successful, the Elite will take up residence on the newly acquired",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("planet.  If the attack fails, the Elite is lost for the rest of the game.",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("If your Elite is on a planet that an enemy attacks and defeats, your Elite",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("is lost for the rest of the game.",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("",style=s),align=-1),colspan=2); t.tr()
    
    f = gui.Form()
    
    t.tr()
    t.td(gui.Label('Planets'))
    t.td(gui.Slider('planets',10,65,value=23))
    t.tr()
    t.td(gui.Label('Homes'))
    t.td(gui.Slider('homes',1,3,value=1))
    t.tr()
    t.td(gui.Label('Production'))
    t.td(gui.Slider('production',15,200,value=100))
    t.tr()
    t.td(gui.Label('Ships'))
    t.td(gui.Slider('ships',15,200,value=100))
    t.tr()
    t.td(gui.Label('Bots'))
    t.td(gui.Slider('bots',1,5,value=1))

    t.tr()
    w = gui.Button('Play Galcon!')
    t.td(gui.Box(w,style={'margin-top':pad}),colspan=2)
    def start():
        r = {}
        for k,v in f.items(): r[k] = v.value
        #################### gnip mod
        l = gniplevel.Level(game,r,app)
        ####################
        app.goto(l)
    w.onclick = start

    return app


class Game:
    pass
    
def main():
    g = Game()
    g.font = galcon.Font(20)
    #l = level.Level(g,False)
    #return l
    r = build_app(g)
    return r
