## Title: gniplevel.py
## Author: Scott O. Nelson (SirGnip)
## License: LGPL (c) 2007 Scott O. Nelson
## Description: The main "Gnip_Revolt" and stats logging mod implementation

import galcon
import classic
import level
import gniputil


class mylevel(level.Level_):
    '''This class was created to be able to override all the stuff I need while
    touching as little of the base mod code (level.py, main.py, etc.) as possible'''

    def copy(self):
        '''override base class version of this function'''
        return Level(self.game,self.opts,self.parent,self.data)

    def init(self):
        level.Level_.init(self)
        self.revoltMod = gniputil.PlanetRevoltMod(self, self.opts['revoltinterval'])
        self.statsLoggingMod = gniputil.StatsLogger(self)

    def loop(self):
        returnVal = classic.Level.loop(self)
        self.revoltMod.loop()
        self.statsLoggingMod.loop()
        return(returnVal)
        
    def paint(self, screen):
        returnVal = level.Level_.paint(self, screen)
        self.revoltMod.paint(screen)
        return(returnVal)
        
    def GameOver(self):
        self.statsLoggingMod.WriteStats()

        
# patterned after function of same name in level.py
def Level(game,parent,opts,data=None):
    l_ = mylevel(game,parent,opts,data)
    l = galcon.Level(l_)
    l_.state = l
    return l
