## Title: Gnip_Revolt
## Author: SirGnip
## License: LGPL (c) 2007 Scott O. Nelson
## Description: One of the leader's planets will occasionally revolt to an enemy.

import galcon
import gui

import level
#################### gnip mod
import gniplevel
####################

version = 0.3

def build_app(game):
    pad = 16
    
    t = gui.Table()
    box = gui.Box(t,width=SW,height=SH,background=galcon.Bkgr())
    app = gui.App(game,box,False)
    
    t.tr()
    t.td(gui.Box(gui.Label('Gnip_Revolt Mod Options',style={'font':galcon.Font(32)}),style={'margin-top':pad}),colspan=2)
    t.tr()
    t.td(gui.Box(gui.Label('(v%s)' % version),style={'margin-bottom':pad}),colspan=2)

    # instructions
    s = {'font':galcon.Font(12)}
    t.tr()
    t.td(gui.Box(gui.Label("Instructions:",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("Every 30 seconds, one of the Leader's planets will revolt.  The",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("new owner will be chosen at random.  The 'Revolt Interval' can",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("be modified using the slider below.",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("",style=s),align=-1),colspan=2); t.tr()
    t.td(gui.Box(gui.Label("",style=s),align=-1),colspan=2); t.tr()
    
    f = gui.Form()
    
    t.tr()
    t.td(gui.Label('Planets'))
    t.td(gui.Slider('planets',10,65,value=23))
    t.tr()
    t.td(gui.Label('Homes'))
    t.td(gui.Slider('homes',1,3,value=1))
    t.tr()
    t.td(gui.Label('Production'))
    t.td(gui.Slider('production',15,200,value=100))
    t.tr()
    t.td(gui.Label('Ships'))
    t.td(gui.Slider('ships',15,200,value=100))
    t.tr()
    t.td(gui.Label('Bots'))
    t.td(gui.Slider('bots',1,5,value=1))
    
    t.tr()
    t.td(gui.Label('Revolt Interval'))
    t.td(gui.Slider('revoltinterval',5,120,value=30))

    t.tr()
    w = gui.Button('Play Galcon!')
    t.td(gui.Box(w,style={'margin-top':pad}),colspan=2)

   
    def start():
        r = {}
        for k,v in f.items(): r[k] = v.value
        #################### gnip mod
        l = gniplevel.Level(game,r,app)
        ####################
        app.goto(l)
    w.onclick = start
    
    return app


class Game:
    pass
    
def main():
    g = Game()
    g.font = galcon.Font(20)
    #l = level.Level(g,False)
    #return l
    r = build_app(g)
    return r
