## Title: Symmetry
## Author: ThirdParty
## License: LGPL (c) 2007 "ThirdParty"
## Description: Symmetric level generator.

import galcon
import gui
import bots

import symlevel

def build_app(game):
	pad = 16
	
	layout = gui.Table()
	layout.tr()
	box = gui.Box(layout,width=SW,height=SH,background=galcon.Bkgr())
	app = gui.App(game,box,False)
	
	f = gui.Form()
	
	# player list
	t = gui.Table(valign=-1,style={'padding':16})
	layout.td(t)
	t.tr()
	t.td(gui.Box(gui.Label('Players',style={'font':galcon.Font(32)}),style={'margin-bottom':pad}),colspan=2)
	
	t.tr()
	w = gui.Checkbox('Human',value=True)
	t.td(gui.Box(w,align=-1))
	t.td(gui.Label('Human',align=-1))

	for i in xrange(0,len(bots.BOTS)):
		b = bots.BOTS[i]
		t.tr()
		w = gui.Checkbox(b[0],value=(i == len(bots.BOTS)-1))
		t.td(gui.Box(w,align=-1))
		t.td(gui.Label(b[0],align=-1))

	# options list	
	t = gui.Table(valign=-1,style={'padding':16})
	layout.td(t)
	
	t.tr()
	t.td(gui.Box(gui.Label('Options',style={'font':galcon.Font(32)}),style={'margin-bottom':pad}),colspan=2)
	
	t.tr()
	t.td(gui.Label('Planets'))
	t.td(gui.Slider('planets',10,65,value=23))
	t.tr()
	t.td(gui.Label('Homes'))
	t.td(gui.Slider('homes',1,3,value=1))
	t.tr()
	t.td(gui.Label('Production/Home'))
	t.td(gui.Slider('production',15,200,value=100))
	t.tr()
	t.td(gui.Label('Ships/Home'))
	t.td(gui.Slider('ships',15,200,value=100))
	
	t.tr()
	t.td(gui.Label('Hill'))
	t.td(gui.Box(gui.Checkbox('hill'),align=-1))
	t.tr(); t.td(gui.Label('Hill Production')); t.td(gui.Slider('hillprod',15,200,value=120))
	t.tr(); t.td(gui.Label('Hill Ships')); t.td(gui.Slider('hillships',0,100,value=50))

	t.tr()
	t.td(gui.Label('Symmetry'))
	t.td(gui.Box(gui.Checkbox('symmetry',value=True),align=-1))

	t = layout
	t.tr()
	w = gui.Button('Play Galcon!')
	t.td(gui.Box(w,style={'margin-top':pad}),colspan=2)
	def start():
		r = {}
		for k,v in f.items(): r[k] = v.value
		l = symlevel.Level(game,r,app)
		app.goto(l)
	w.onclick = start
	
	return app


class Game:
	pass
	
def main():
	g = Game()
	g.font = galcon.Font(20)
	#l = level.Level(g,False)
	#return l
	r = build_app(g)
	return r
