# corrected "classic.py"

import galcon
import dialog

class Level(galcon.State):
	# the classic level requires
	# .copy - a copy of this level to retry
	# .timer - set to 0
	# .frame - set to 0
	# .parent - parent to return to 
	# .state - the state we're actually in ..
	# .help - game info
	
	def loop(self):
		for u in self.users.values():
			u.loop()
			
		for p in self.planets.values():
			if p.user.n == 0: continue
			p.ships += p.production / (galcon.FPS*50.0)
			
		livingteam,twosides,twofleets = 0,False,False
		for p in self.planets.values():
			if not isinstance(p.user,galcon.Neutral):
				if livingteam == 0:
					livingteam = p.user.team
				elif p.user.team != livingteam:
					twosides = True
		if twosides: twofleets = True
		else:
			for f in self.fleets.values():
				if livingteam == 0:
					livingteam = f.user.team
				elif f.user.team != livingteam:
					twofleets = True
		# self.player.team
		if twosides:
			# so long as everyone has planets, the timer stays at thirty seconds
			self.timer = FPS*30
		else:
			# when one side has no planets, the timer starts ticking down
			self.timer -= 1
			if (not twofleets) and (self.timer > FPS*2):
				# if one side is eliminated, lower the timer to two seconds if necessary
				self.timer = FPS*2
			# end the game when the timer reaches zero
			if self.timer < 1:
				if livingteam == self.player.team:
					return dialog.Pause(self.game,'good job!',self.parent)
				else:
					return dialog.Prompt(self.game,'try again?',self.copy,self.parent)
			
		self.frame += 1
	
	def fleet(self,user,from_,to,ships):
		if from_.user != user or ships <= 0: return
		f = galcon.Fleet()
		f.user = user
		f.from_ = from_
		f.to = to
		f.ships = min(ships, from_.ships)
		from_.ships -= f.ships
		self.fleets.add(f)
		
	def redirect(self,user,from_,to):
		if from_.user != user: return
		from_.to = to
		
	def hit(self,fleet,ships,p):
		s = p.ships
		if p.user.team == fleet.user.team:
			p.ships += ships
		else:
			p.ships -= ships
			if p.ships < 0:
				p.ships = -p.ships
				p.user = fleet.user
		return p.ships-s
	
	def event(self,e):
		if e.type is KEYDOWN and e.key == K_ESCAPE:
			return dialog.Choice(self.game,None,[
				('continue',K_c,self.state),
				('restart',K_r,self.copy),
				('quit',K_q,self.parent),
				])
		 
	def paint(self,screen):
		if self.first:
			self.first = False
			return dialog.Help(self.game,self.help,self.state)
