## Title: ThirdMissions
## Author: ThirdParty
## Description: A set of interesting single-player missions.

import galcon
# import random
# rr = random.randrange
import gui
import colorscheme

import msn_imperium
import msn_goliath
import msn_rebellion
import msn_pairs
import msn_crusher
import msn_classic
import msn_vacuum
import msn_wormhole
	
class PWidgetC(gui.Widget):
	def __init__(self,n,c,sz,**params):
		gui.Widget.__init__(self,**params)
		self.n = n
		self.c = c
		self.size = sz
		self.style['width'],self.style['height'] = sz+20,sz+20
		
	def paint(self,s):
		sz = self.size + 8*('hover' in self.pseudo)
		pos = (s.get_width()/2,s.get_height()/2)
		r = sz/2
		s.planet(self.c,pos,r,None,self.n)

mdata = [ # (built, title, Level function, planet color)
	(True, 'Classic', msn_classic.Level, colorscheme.human),
	(False, '', None, (0,0,0)),
	(True, 'Goliath', msn_goliath.Level, colorscheme.cobra),
	(True, 'Pairs', msn_pairs.Level, colorscheme.lass),
	(True, 'Imperium', msn_imperium.Level, colorscheme.newbie),
	(False, '', None, (0,0,0)),
	(True, 'Crusher', msn_crusher.Level, colorscheme.exterminator),
	(False, '', None, (0,0,0)),
	(True, 'Wormhole', msn_wormhole.Level, colorscheme.wormhole),
	(True, 'Rebellion', msn_rebellion.Level, colorscheme.vendetta),
	(False, '', None, (0,0,0)),
	(True, 'Vacuum', msn_vacuum.Level, (96,96,96))
	]

def build_app(game):
	pad = 16
	
	layout = gui.Table()
	box = gui.Box(layout,width=SW,height=SH,background=galcon.Bkgr())
	app = gui.App(game,box,False)
	
	f = gui.Form()
	t = layout
	t.tr()

	# we've got ten columns, with most of the action happening in the middle four

	# title
	z = 360
	logo = galcon.misc_get_logo()
	logo = logo.scale((z,logo.get_height()*z/logo.get_width()))

	t.td(gui.Box(gui.Image(logo)),colspan=10)

	# difficulty

	s = {'font':galcon.Font(16)}

	t.tr()
	t.td(gui.Box(gui.Label('Difficulty:',style={'font':galcon.Font(16)}),valign=-1))
	g = gui.Group('handicap', value=0)
	t.td(gui.Box(gui.Radio(g,7))); t.td(gui.Box(gui.Label('Ens.',style=s),align=-1))
	t.td(gui.Box(gui.Radio(g,6))); t.td(gui.Box(gui.Label('Lieut.',style=s),align=-1))
	t.td(gui.Box(gui.Radio(g,5))); t.td(gui.Box(gui.Label('Lt-Cmdr.',style=s),align=-1))
	t.td(gui.Box(gui.Radio(g,4))); t.td(gui.Box(gui.Label('Cmdr.',style=s),align=-1))
	t.td(gui.Label('		  '))
	t.tr()
	t.td(gui.Label('   '))
	t.td(gui.Box(gui.Radio(g,3))); t.td(gui.Box(gui.Label('Capt.',style=s),align=-1))
	t.td(gui.Box(gui.Radio(g,2))); t.td(gui.Box(gui.Label('Cdre.',style=s),align=-1))
	t.td(gui.Box(gui.Radio(g,1))); t.td(gui.Box(gui.Label('Adm.',style=s),align=-1))
	w = gui.Radio(g,0); t.td(gui.Box(w)); t.td(gui.Box(gui.Label('Flt-Adm.',style=s),align=-1)); w.focus()
	t.td(gui.Label('		  '))

	# missions

	t.tr(); t.td(gui.Label('   '))
	t.tr()
	t.td(gui.Box(gui.Label('Missions:',style={'font':galcon.Font(16)}),valign=-1))

	def startlevel(m):
		def startlevel():
			r = {}
			for k,v in f.items(): r[k] = v.value
			l = mdata[m][2](game,app,r['handicap'])
			app.goto(l)
		return startlevel

	for m in xrange(0,len(mdata)):
		if mdata[m][0]:
			tt = gui.Table(width=108)
			tt.tr()
			w = PWidgetC(m,mdata[m][3],32,style={'margin-top':pad/2})
			tt.td(w)
			w.onclick = startlevel(m)
			tt.tr()
			tt.td(gui.Box(gui.Label(mdata[m][1],style={'font':galcon.Font(16)}),style={'margin-bottom':pad/2}))
			t.td(tt, colspan=2)
		else:
			t.td(gui.Label('   ')); t.td(gui.Label('   '))
		if m%4 == 3:
			t.tr()
			t.td(gui.Label('   '))
	
	return app

class Game:
	pass
	
def main():
	g = Game()
	g.font = galcon.Font(20)
	r = build_app(g)
	return r
