## Author: ThirdParty
## License: Public Domain
## Description: "Trade places" tutorial level.

import galcon
import random
rr = random.randrange
import math

import bot
import classic
import dialog
import mapfile

class Level_(classic.Level):
	def __init__(self,game,parent,blue = True,data = None):
		self.game = game
		self.parent = parent
		self.data = data
		self.blue = blue
		
	def init(self):
		# set up the defense
		if self.blue:
			u = galcon.Player()
			self.player = u
		else:
			u = bot.Bot(self)
		u.name = 'Defense'
		self.users.add(u)

		# set up the offense
		if self.blue:
			u = bot.Bot(self)
		else:
			u = galcon.Player()
			self.player = u
		u.name = 'Offense'
		self.users.add(u)

#		self.options.hide_stats = 0
		
		if self.data == None:
			self.generate()
			self.data = mapfile.tostring(self)
		else:
			mapfile.fromstring(self,self.data)
			
		self.sync()

		# initialize all the users / bots
		for u in self.users.values():
			u.init()
			
		# misc
		self.timer,self.frame,self.first = 0,0,True
		
	def copy(self):
		return Level(self.game,self.parent,self.blue,self.data)
	
	def generate(self):
		# blue homeworld
		p = galcon.Planet()
		p.production = 100
		p.ships = 100
		p.pos = 542,329
		p.user = self.users[1]
		self.planets.add(p)

		# red homeworld
		p = galcon.Planet()
		p.production = 100
		p.ships = 100
		p.pos = 97,150
		p.user = self.users[2]
		self.planets.add(p)
		
		# blue colony
		p = galcon.Planet()
		p.production = 61
		p.ships = 22
		p.pos = 473,281
		p.user = self.users[0]
		self.planets.add(p)
		
		# red colony
		p = galcon.Planet()
		p.production = 23
		p.ships = 2
		p.pos = 108,221
		p.user = self.users[0]
		self.planets.add(p)

		# distractors
		p = galcon.Planet()
		p.production = 13
		p.ships = 47
		p.pos = 511,146
		p.user = self.users[0]
		self.planets.add(p)

		p = galcon.Planet()
		p.production = 9
		p.ships = 42
		p.pos = 251,298
		p.user = self.users[0]
		self.planets.add(p)

		p = galcon.Planet()
		p.production = 4
		p.ships = 30
		p.pos = 347,120
		p.user = self.users[0]
		self.planets.add(p)
		
		# set the scale
		self.options.scale = 1.0
		
		# sync
		self.sync()

def Level(game,parent,blue=False,data=None):
	l_ = Level_(game,parent,blue,data)
	l = galcon.Level(l_)
	l_.state = l
	return l
	