## Title: Trading Places
## Author: ThirdParty
## License: Public Domain
## Description: Learn to use the "Trade Places" maneuver.

import galcon
import gui

import level

def build_app(game):
	pad = 16
	
	layout = gui.Table()
	layout.tr()
	box = gui.Box(layout,width=SW,height=SH,background=galcon.Bkgr())
	app = gui.App(game,box,False)
	
	f = gui.Form()
	t = layout

	# title
	t.td(gui.Box(gui.Label('TRADING PLACES',style={'font':galcon.Font(48)}),style={'margin-bottom':pad}),colspan=4)
	t.tr()

	# info

	s = {'font':galcon.Font(12)}

	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('When you are attacked by someone larger', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('than you, it is sometimes possible to', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('trade places with him by attacking him', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('with everything you have (not defending).', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('To counter this maneuver, be careful', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('not to use too many ships when', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('attacking a smaller player.', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('Click "Offense" to try the maneuver.', style=s),align=-1),colspan=2); t.tr()
	t.td(gui.Label('     ')); t.td(gui.Box(gui.Label('Click "Defense" to try countering it.', style=s),align=-1),colspan=2); t.tr()

	# actions

	t.td(gui.Label('    ')); t.tr()

	t.td(gui.Label('     '))

	w = gui.Button('Offense')
	t.td(gui.Box(w),colspan=1)
	def start_red():
		r = {}
		for k,v in f.items(): r[k] = v.value
		l = level.Level(game,app,False)
		app.goto(l)
	w.onclick = start_red

	w = gui.Button('Defense')
	t.td(gui.Box(w),colspan=1)
	def start_blue():
		r = {}
		for k,v in f.items(): r[k] = v.value
		l = level.Level(game,app,True)
		app.goto(l)
	w.onclick = start_blue

	t.td(gui.Label('     '))
	
	return app


class Game:
	pass
	
def main():
	g = Game()
	g.font = galcon.Font(20)
	r = build_app(g)
	return r
