## Title: Bot Wars! (w/ Tournament Mode)
## Description: Watch bots battle to the death!
# Author: Phil Hassey / ThirdParty
## License: LGPL (c) 2007 "ThirdParty"

import galcon
import random
import gui

import bots
import level

class War(galcon.State):
	def __init__(self,game,opts,parent):
		self.game,self.opts,self.parent =game,opts,parent
		self.game.rounds = 0
		self.data = None

		self.game.sets = 0
		nums = range(0,len(game.bots))
		botsPer = self.opts['bots']
		self.orders = []
		for i in nums:
			for j in nums:
				if i != j: self.orders.append([i,j])
		orderLength = 2
		while orderLength < botsPer:
			orderLength += 1
			newOrders = []
			for a in self.orders:
				for n in nums:
					if not (n in a):
						entry = []
						for i in xrange(0,len(a)):
							entry.append(a[i])
						entry.append(n)
						newOrders.append(entry)
			self.orders = newOrders
		self.i = 0

#		string = ""
#		for i in range(0,len(self.orders)):
#			string += "\r."
#			for j in range(0,len(self.orders[i])):
#				string += "%d,"%self.orders[i][j]
#		galcon.file_save('log.txt',string)

	def loop(self):
		if not self.opts['tourney']:
			return level.Level(self.game,self.opts,self)
		else:
			if self.i >= len(self.orders):
				self.game.rounds = 0
				self.game.sets += 1
				self.i = 0
			if self.i == 0:
				random.shuffle(self.orders)
				self.l = level.Level(self.game,self.opts,self,self.orders[self.i])
				self.i += 1
				return self.l
			else:
				self.l = level.Level(self.game,self.opts,self,self.orders[self.i],self.data)
				self.i += 1
				return self.l

def build_app(game):
	pad = 16
	
	layout = gui.Table()
	layout.tr()
	box = gui.Box(layout,width=SW,height=SH,background=galcon.Bkgr())
	app = gui.App(game,box,False)
	
	f = gui.Form()
	
	# bots list
	t = gui.Table(valign=-1,style={'padding':16})
	layout.td(t)
	t.tr()
	t.td(gui.Box(gui.Label('Bots',style={'font':galcon.Font(32)}),style={'margin-bottom':pad}),colspan=2)
	
	for bot in bots.BOTS:
		t.tr()
		w = gui.Checkbox(bot.name,value=True)
		t.td(gui.Box(w,align=-1))
		t.td(gui.Label(bot.name,align=-1))
	
	# options list
	t = gui.Table(valign=-1,style={'padding':16})
	layout.td(t)
	
	t.tr()
	t.td(gui.Box(gui.Label('Options',style={'font':galcon.Font(32)}),style={'margin-bottom':pad}),colspan=2)
	
	
	t.tr()
	t.td(gui.Label('Planets'))
	t.td(gui.Slider('planets',10,65,value=31))
	t.tr()
	t.td(gui.Label('Homes'))
	t.td(gui.Slider('homes',1,3,value=1))
	t.tr()
	t.td(gui.Label('Production'))
	t.td(gui.Slider('production',15,200,value=100))
	t.tr()
	t.td(gui.Label('Ships'))
	t.td(gui.Slider('ships',15,200,value=100))
	t.tr()
	t.td(gui.Label('Bots'))
	t.td(gui.Slider('bots',2,len(bots.BOTS),value=2))
	t.tr()
	t.td(gui.Label('Speed'))
	t.td(gui.Slider('speed',1,FPS,value=8))
	t.tr()
	t.td(gui.Label('Timeout'))
	t.td(gui.Slider('timeout',0,15,value=5))
	#t.tr()
	#t.td(gui.Label('Seed'))
	#t.td(w = gui.Input('seed_',value='0'))

	t.tr()
	t.td(gui.Label('Variation?'))
	t.td(gui.Box(gui.Checkbox('variation', value = True),align=-1))
	t.tr()
	t.td(gui.Label('Tournament:'))
	t.td(gui.Box(gui.Checkbox('tourney', value = True),align=-1))
	

	t = layout
	t.tr()
	w = gui.Button('BotWar!')
	t.td(gui.Box(w,style={'margin-top':pad}),colspan=2)
	def start():
		r = {}
		for k,v in f.items(): r[k] = v.value
		game.bots = []
		game.unsortedbots = []
		for bot in bots.BOTS:
			if r[bot.name]:
				game.bots.append(bot)
				game.unsortedbots.append(bot)
		app.goto(War(game,r,app))
	w.onclick = start
	
	
	
	
	return app




class Game:
	pass
	
def main():
	g = Game()
	g.font = galcon.Font(20)
	#l = level.Level(g,False)
	#return l
	r = build_app(g)
	return r
