import galcon
import gui
import dialog
import level

import bot5000
Bot5000 = bot5000.Bot5000

mdata = [
 ('mission2','Start!',
        'classic galcon mission, 1 on 1',
        [(0,21,None,None), (1,1,100,100),   (2,1,100,100,    Bot5000,[95,])],
        
            )
            ]
    
import diffs
class PWidget(gui.Widget):
    def __init__(self,n,sz,**params):
        gui.Widget.__init__(self,**params)
        self.n = n
        self.size = sz
        self.style['width'],self.style['height'] = sz+50,sz+50
        
        
    def paint(self,s):
        sz = self.size + 8*('hover' in self.pseudo)
        pos = (s.get_width()/2,s.get_height()/2)
        r = sz/2
        s.planet(COLORS[self.n%len(COLORS)],pos,r,None,self.n)


class MissionMenu(gui.App):
    def __init__(self,game,parent):
        self.game =game
        self.parent = parent
        self.next = None
        self.widget = None

    def init(self):
        galcon.misc_music_play('missions')
        f = gui.Form()
        bkgr = galcon.Bkgr()
        logo = galcon.misc_get_logo()
        z = 400
        logo = logo.scale((z,logo.get_height()*z/logo.get_width()))
        bkgr.blit(logo,((SW-z)/2,0))
        self.widget = t = gui.Table(background=bkgr)
        
        app = self
        

        t.tr()
        t.td(gui.Spacer(1,100))
        pad = 8

        g = gui.Group(name='diff',value=diffs.get_diff()) #self.game.cfg['diff'])
        def onchange():
            diffs.set_diff(g.value)
        g.onchange = onchange
        
        tt = gui.Table()
        
        tt.tr()
        self.form = f
        n = 0
        
        for v,spd,txt in diffs.DIFFS:
            tt.td(gui.Radio(g,value=v))
            tt.td(gui.Box(gui.Label(txt),style={'padding-left':pad,'padding-right':pad*3}))
            
            n += 1
            if n == 4:
                tt.tr()
                tt.td(gui.Spacer(4,4))
                tt.tr()
            
        t.tr()
        t.td(tt,colspan=4)

        t.tr(); t.td(gui.Spacer(pad*1,pad*1))
        
        my_t =t

        t = gui.Table()

        n = 0
        for name,title,desc,stats in mdata[:]:
            if (n%5) == 0:
                t.tr()

            tt = gui.Table(width=108)
            tt.tr()
            w = PWidget(n,120,style={'margin-top':pad/2})
            
            tt.td(w)
            w.onclick = self.pclick(stats)
            #w.connect(gui.CLICK,self.my_action,self.action_start,stats)


            tt.tr()
            tt.td(gui.Box(gui.Label(title),style={'margin-bottom':pad/2}))
            t.td(tt)


            n += 1

        missions = t

        t = my_t

        t.tr()
        t.td(gui.Spacer(pad*1,pad*1))

        t.tr()
        t.td(missions,colspan=4)

        t.tr()
        t.td(gui.Spacer(pad*2,pad*2))
        t.tr()
        w = gui.Button('Back to Main Menu')
        w.onclick = self.action_menu
        #w.connect(gui.CLICK,self.my_action,self.action_menu)
        t.td(gui.Box(w),colspan=4)
        
    def pclick(self,stats):
        def onclick():
            return self.action_start(stats)
        return onclick


    def action_menu(self):
        self.goto(self.parent)

    def action_start(self,stats):
        
        l = level.Level(self.game,stats,self)
        self.goto(l)

