import gui
import galcon

min_speed,max_speed = 1,6

#sfx = {
    #'enter':galcon.Sound('enter.wav'),
    #'click':galcon.Sound('click.ogg'),
    
#}
#sfx['enter'].set_volume(0.25)
    
class MyButton(gui.Button):
    def __init__(self,min_size,max_size,reg,app,dname,*p1,**p2):
        self.min_size,self.max_size = min_size,max_size
        gui.Button.__init__(self,*p1,**p2)
        self.size = min_size
        self.speed = 1
        self.reg = reg
        
        self.frame = 0
        self.app = app 
        self.dname = dname
        
        self.loop()
    def onclick(self):
        if self.reg:
            #sfx['click'].play()
            self.app.goto(self.dname)
    #def event(self,e):
        #if e.type is gui.ENTER:
            #sfx['enter'].play()
        
    def loop(self):
        if 'hover' in self.pseudo:
            if self.size < self.max_size:
                self.size = min(self.max_size,self.size+self.speed)
                self.speed = min(max_speed,self.speed+1)
            else:
                self.speed = max(min_speed,self.speed-1)
                
            self.label.content = self.description
            self.label.change()
        else:
            if self.size > self.min_size:
                self.size = max(self.min_size,self.size-self.speed)
                self.speed = min(max_speed,self.speed+1)
            else:
                self.speed = max(min_speed,self.speed-1)
        self.style['width'] = self.style['height'] = self.size
        
        self.frame += 1
        
    def paint(self,screen):
        gui.Button.paint(self,screen)
        
        #if 1: #self.size > (min_size+max_size)/2:
        
        
        if self.size > self.min_size:
            if not self.reg:
                v = abs((self.frame%FPS)*510/FPS-255)
                c = (v,192+v/4,255)
                w = gui.Document('only\navailable to\nregistered\nusers',width=120,valign=0,style={'color':c})
                width,height = w.resize()
                if screen.get_width() > width and screen.get_height() > height:
                    w.paint(screen)
            
            w = gui.Label(self.title,valign=1)
            width,height = w.resize()
            if screen.get_width() > width:
                w.paint(screen)
        
        
class MyImage(gui.Image):
    def resize(self,width=None,height=None):
        if width != None and height != None:
            s = self.content
            sw,sh = s.get_width(),s.get_height()
            if sw > sh: height = height*sh/sw
            else: width = width*sw/sh 
                
            if (width,height) != (self.style['width'],self.style['height']):
                self.style['width'],self.style['height'] = width,height
                self.change()
        return self.surf.get_width(),self.surf.get_height()


class Color(gui.Widget):
    def __init__(self,content,**params):
        gui.Widget.__init__(self,**params)
        self.klass = 'color'
        self.content = content
    def paint(self,screen):
        screen.fill(self.content)
    #def resize(self,width,height):
        #return max(width,self.style['width']),max(height,self.style['height'])
        
    

class Game:
    pass
    
def main():
    galcon.misc_music_play('missions')
    
    g = Game()
    g.font = galcon.Font(20)
    
    tt = gui.Table(width=SH,height=SH,background=galcon.Bkgr())
    app = gui.App(g,tt,False)
    
    mods = galcon.misc_mods_list()
    
    top = ['classic','missions','thirdmissions.zip',
        'gnip_nuke.zip','symmetry.zip','nibbles','thirdedit.zip','gnip_elite.zip']
        
    def mysort(a,b):
        ai = 100
        bi = 100
        if a['name'] in top: ai = top.index(a['name'])
        if b['name'] in top: bi = top.index(b['name'])
        if ai != bi: return cmp(ai,bi)
        return cmp(a['name'],b['name'])
        
    mods.sort(mysort)
    
    total = len(mods)
    total = min(105,total)
    mods = mods[:total]
    settings = [
        (6,     3,  2,  8,  96,     192),
        (15,    5,  3,  4,  64,     192),
        (28,    7,  4,  3,  48,     160),
        (40,    8,  5,  3,  40,     128),
        (60,   10,  6,  2,  32,     128),
        (105,  15,  7,  2,  24,     96),
    ]
    for n,cols,rows,margin,min_size,max_size in settings:
        if total <= n: break
    
    first = None
    label = gui.Label('')
    n = 0
    t_icons = t = gui.Table()
    for info in mods:
        title = info['title']
        desc = info.get('description',title)
        #if 'title' in info: title += ' - '+info['title']
        #if 'author' in info: title += ' - '+info['author']
        if (n%cols)==0: t.tr()
        e = MyImage(info['icon'],background=(0,0,0))
        rg = True
        dname = info['dname']
        if not info['reg']:
            rg = False
            next = None
        w = MyButton(min_size,max_size,rg,app,dname,e,style={'margin':margin})
        w.label,w.title,w.description = label,title,desc
        if first == None: first = w
        t.td(gui.Box(w))
        n += 1
            
            
    #f = gui.Form()
    #t_level = t = gui.Table()
    #t.tr()
    #t.td(gui.Box(gui.Label('Level'),width=150))
    #w1 = gui.Slider('slider',0,100,value=0,width=200)
    #t.td(w1)
    #w2 = gui.Label('')
    #t.td(gui.Box(w2,width=150))
    #def onchange():
        #ranks = ['Cabin Boy','Ensign','Lieutenant','Commander','Captain',        'Admiral','Grand Admiral']
        #v = w1.value * (len(ranks)-1) / 100
        #w2.content = ranks[v]
        #w2.change()
    #w1.onchange = onchange
    #w1.onchange()
    
            
    #tt.tr()
    #tt.td(t_level)
    
    #tt.tr()
    #tt.td(gui.Label('Single Player',style={'font':gui.Font(32)},height=(80-24)))
    tt.tr();tt.td(gui.Spacer(1,12))
    tt.tr();tt.td(gui.Box(t_icons,height=380,width=SW))
    tt.tr();tt.td(gui.Spacer(1,12))
    def loop():
        label.content = ''
        label.change()
        gui.Table.loop(tt)
    tt.loop = loop
    tt.tr();tt.td(label)
    tt.tr();tt.td(gui.Spacer(1,12))
    w = gui.Button('Back to Main Menu')
    def onclick():
        app.goto(app.parent)
    w.onclick = onclick
    tt.tr();tt.td(gui.Box(w))
    tt.tr();tt.td(gui.Spacer(1,12))
    
    first.focus()
    
    
    return app

