## Title: Map Test
## Author: Phil Hassey
## License: Public Domain
## Description: Basic level testing code.

import galcon
import bot
import mapfile
import classic
import dialog

class Level_(classic.Level):
    def __init__(self,game,data,parent):
        self.game = game
        self.data = data
        self.parent = parent
        
    def init(self):
        # set up the player
        u = galcon.Player()
        u.name = 'player'
        self.users.add(u)
        self.player = u

        for n in xrange(2,13):
            # set up the bot
            u = bot.Bot(self)
            u.name = 'bot'
            self.users.add(u)
        
        # load in the goods
        mapfile.fromstring(self,self.data)
        
        # initialize all the users / bots
        for u in self.users.values():
            u.init()
        
        # misc
        self.timer,self.frame,self.first = 0,0,True
        
    def copy(self):
        return Level(self.game,self.data,self.parent)
         
def Level(game,data,parent):
    l_ = Level_(game,data,parent)
    l = galcon.Level(l_)
    l_.state = l
    return l
    
