import random
import galcon

class Bot5000(galcon.Bot):
    def __init__(self,smart):
        galcon.Bot.__init__(self)
        self.smart = smart
        self.speed = FPS
    
    def init(self):
        self.planets = {}
        for pid,p in self.level.planets.items():
            self.planets[pid] = galcon.Wrapper(p)
            
        td = 0
        nd = 0
            
        #calculate distances between planets
        for p1 in self.planets.values():
            p1.dists = {}
            for p2 in self.planets.values():
                if p1 == p2: continue
                dx,dy = p2.rect.centerx-p1.rect.centerx,p2.rect.centery-p1.rect.centery
                p1.dists[p2] = (dx*dx+dy*dy)**0.5
                td += p1.dists[p2]
                nd += 1
                
        td /= nd
        self.avg_dist = td
        #print self.avg_dist
        
        self.frame = random.randrange(0,FPS)
        
            
    def calc(self,me):
        #calculate basic values
        for p in self.planets.values():
            #speed not included as speed is re-calculated in with the blur
            #p.value = \
                #(p.production)*v_production + \
                #(p.attack + p.defence)*v_attributes + \
                #(p.u_attack + p.u_speed + p.u_defence)*v_upgrades + \
                #0
            p.value = p.production
            p.fleets = 0
            
        for f in self.level.fleets.values():
            p = self.planets[f.to.n]
            if f.user.team != p.user.team:
                p.fleets -= f.ships #*f.attack/p.defence
            else:
                p.fleets += f.ships

        ships_total = 0
        ships_self = 0
        ships_enemy = 0
        ships_neutral = 0
        
        production_total = 0
        production_self = 0
        production_enemy = 0
        production_neutral = 0
        
        for p in self.planets.values():
            ships_total += p.ships
            production_total += p.production
            if p.user.team == me.team:
                ships_self += p.ships
                production_self += p.production
            elif isinstance(p.user,galcon.Neutral):
                ships_neutral += p.ships
                production_neutral += p.production
            else:
                ships_enemy += p.ships
                production_enemy += p.production
                
        ships_total = int(ships_total)
        ships_self = int(ships_self)
        ships_enemy = int(ships_enemy)
        ships_neutral = int(ships_neutral)
        
        fleets_total = 0
        fleets_self = 0
        fleets_enemy = 0
        fleets_neutral = 0
        
        for f in self.level.fleets.values():
            if p.user.team == me.team:
                fleets_self += f.ships
            elif isinstance(f.user,galcon.Neutral):
                fleets_neutral += f.ships
            else:
                fleets_enemy += f.ships

        self.my_stats = {
            'ships_total':ships_total,'ships_self':ships_self,'ships_enemy':ships_enemy,'ships_neutral':ships_neutral,
            'production_total':production_total,'production_self':production_self,'production_enemy':production_enemy,'production_neutral':production_neutral,
            'fleets_total':fleets_total,'fleets_self':fleets_self,'fleets_enemy':fleets_enemy,'fleets_neutral':fleets_neutral,
            }
            
        return self.my_stats
            
            
    def loop(self):
        self.frame += 1
        if (self.frame%self.speed) != 0: return
        
        smart = int(self.smart * 100)
        if random.randrange(0,100) > smart:
            planets = [p for p in self.planets.values() if p.user == self]
            if not len(planets): return
            p1 = random.choice(planets)
            planets = [p for p in self.planets.values()]
            if not len(planets): return
            p2 = random.choice(planets)
            ships = int(p1.ships)
            if not ships: return
            ships = max(14,random.randrange(0,ships))
            self.level.fleet(self,p1.item,p2.item,ships)
            return
            
        
        self.calc(self)
            
        #show values
        #for p in self.planets.values():
            #self.level.planets[p.n].value = p.value
        #self.level.stat = 'value'
        #self.level.options.hidemy_stats = False
                
                
        s = self.my_stats
        m = 0.001        
        
        v_prod_total = float(s['production_self']+s['production_enemy'])/max(m,float(s['production_total']))
        v_prod_balance = float(s['production_self']-s['production_enemy'])/max(m,float(s['production_self']+s['production_enemy']))
        v_ships_balance = float((s['ships_self']+s['fleets_self'])-(s['ships_enemy']+s['fleets_enemy']))/max(m,float((s['ships_self']+s['fleets_self'])+(s['ships_enemy']+s['fleets_enemy'])))
        
        n_planets = 0
        for p in self.planets.values():
            if not isinstance(p.user,galcon.Neutral):
                n_planets += 1
        avg_ships1 = (s['ships_self']+s['fleets_self']+s['ships_enemy']+s['fleets_enemy']) / max(1,n_planets)
        avg_ships2 = (s['ships_total'] + s['fleets_total']) / len(self.planets)
        #avg_ships = (avg_ships1+avg_ships2)/2
        #avg_ships = min(avg_ships1,avg_ships2)
        avg_ships = avg_ships1
        #avg_ships = avg_ships1
        #avg_ships = avg_ships1
        
        n_planets = 1
        for p in self.planets.values():
            if p.user.team != self.team and not isinstance(p.user,galcon.Neutral):
                n_planets += 1
        avg_ships = ((s['ships_enemy']+s['fleets_enemy']) / max(1,n_planets))+1
        
        avg_dist = self.avg_dist
        
        #print avg_ships
        
        
        #print 'prod_total: %2.3f, prod_balance: %2.3f, ships_balance: %2.3f'%(v_prod_total,v_prod_balance,v_ships_balance)
        #show values
        #for p in self.planets.values():
            #self.level.planets[p.n].value = p.value
        #for p in self.planets.values():
            #self.level.planets[p.n].value = 0
        #self.level.stat = 'value'
        #self.level.options.hidemy_stats = False
        #for value,ships,p1,p2 in values:
            #self.level.planets[p2.n].value = value

        #calculate initial values and ship requirements of each planet
        for p2 in self.planets.values():
            if p2.user.team == self.team: #defence
                dest = (25 * avg_ships * p2.value / (100*100))
                p2.need = (dest - p2.ships) - p2.fleets
                p2.reserve = max(0,(dest - p2.fleets) * 125 / 100)
                #p2.value *= 1.5
                
                #finish him!! (don't bother with defence .. just finish the job)
                if v_ships_balance > 0.20 and v_prod_balance > 0.20:
                    p2.value /= 2
                if v_ships_balance > 0.40 and v_prod_balance > 0.40:
                    p2.value /= 2
                    
            elif isinstance(p2.user,galcon.Neutral): #neutral
                dest = (50 * avg_ships * p2.value / (100*100))
                p2.need = dest + p2.ships + p2.fleets
                
                #best not to attack when you need to store up ships
                if v_ships_balance < -0.10:
                    p2.value /= 2
                if v_ships_balance < -0.20:
                    p2.value /= 2
            else: #attack
                dest = (100 * avg_ships * p2.value / (100*100))
                p2.need = dest + p2.ships + p2.fleets
                
                #best not to attack when you need to store up ships
                if v_ships_balance < -0.10:
                    p2.value /= 2
                if v_ships_balance < -0.20:
                    p2.value /= 2
                    
                #the best way to tip production balance it to take
                #over a few planets
                if v_prod_balance < -0.10:
                    p2.value *= 2
                if v_prod_balance < -0.20:
                    p2.value *= 2
                    
                #finish him!!
                if v_ships_balance > 0.20 and v_prod_balance > 0.20:
                    p2.value *= 2
                if v_ships_balance > 0.40 and v_prod_balance > 0.40:
                    p2.value = (p2.value+100)*100

                
        #search for an attack that will work
        for n in xrange(0,3):
            values = []
            
            #p1s = [p1 for p1 in self.planets.values() if p1.user == self and p1.need <= 0]
            p1s = [p1 for p1 in self.planets.values() if (p1.user == self and p1.ships > p1.reserve)]
            p2s = [p2 for p2 in self.planets.values() if (p2.need > 0)]
            
            #print len(p1s)*len(p2s)
            for p1 in p1s:
                for p2 in p2s:
                    if p1 == p2: continue
                    
                    dist = p1.dists[p2]
                    ships = p2.need
                    
                    vv = (p2.value) * 100
                    dv = (p2.value*avg_dist/dist) * 300
                    sv = (p2.value*avg_ships/ships) * 200
                    #print p2.production,vv,dv,sv
                    value = vv+dv+sv
                    values.append((value,ships,p1,p2))
                    
            if not len(values): return
                    
            for p2 in self.planets.values():
                p2.value = 0
                p2.need = 0
                p2.used = 0
                    
            values.sort()
            values.reverse()
            
            best = []
            for value,ships,p1,p2 in values:
                if not p1.used:
                    best.append((value,ships,p1,p2))
                    p1.used = True 
                    
            min_ships = 14
                    
            values = best
            while len(values):
                value,ships,p1,p2 = values.pop(0)
                ships = max(min_ships,ships)
                
                from_ = [p1]
                avail = p1.ships - p1.reserve
                ns = []
                myn = 0
                for v2,s2,p1_2,p2_2 in values[:]:
                    if p2_2 == p2 and (p1.ships-p1.reserve) >= min_ships:
                        from_.append(p1_2)
                        avail += p1.ships-p1.reserve
                        ns.append(myn)
                        #NOTE: this does some cleanup
                        del values[myn]
                    else:
                        myn += 1
                        
                if avail < ships:
                    for p1 in from_:
                        p1.value = value
                        p1.need = ships
                    continue
                        
                for p1 in from_:
                    av = p1.ships-p1.reserve
                    send = min(ships,av)
                    send = max(min_ships,send)
                    self.level.fleet(self,p1.item,p2.item,send)
                    ships -= av
                    if ships <= 0: break
                return
            
            #print n,len(values)
            #while len(values):
                #value,ships,p1,p2 = values.pop()
                #if p1.value: continue
                #ships = max(14,ships)
                #if (p1.ships-ships) < p1.reserve:
                    #if not p1.value:
                        #p1.value = max(p1.value,value)
                        #p1.need = max(p1.need,ships)
                    #continue
                #self.fleet(p1.item,p2.item,ships)
                #print n,ships
                #return
