import random
import galcon

class Combo(galcon.Bot):
    def __init__(self,bots):
        """ bots is a list of [(weight,class)]"""
        galcon.Bot.__init__(self)
        self.my_bots = bots
        self.speed = FPS
        #print bots
        
    def init(self):
        self.bots = []
        for w,bc in self.my_bots:
            self.bots.append((w,bc()))
        
        self.weight = 0
            
        for w,b in self.bots:
            self.weight += w
            b.level = self.level
            b.team = self.team
            b.init()
            
        self.planets = {}
        for pid,p in self.level.planets.items():
            self.planets[pid] = galcon.Wrapper(p)
            
        td = 0
        nd = 0
            
        #calculate distances between planets
        for p1 in self.planets.values():
            p1.dists = {}
            for p2 in self.planets.values():
                if p1 == p2: continue
                dx,dy = p2.rect.centerx-p1.rect.centerx,p2.rect.centery-p1.rect.centery
                p1.dists[p2] = (dx*dx+dy*dy)**0.5
                td += p1.dists[p2]
                nd += 1
                
        td /= nd
        self.avg_dist = td
        #print self.avg_dist
        self.frame = random.randrange(0,FPS) 
                 
    def normalize(self,b):
        min_ = 0xffff
        max_ = -0xffff
        for p in b.planets.values():
            if p.value != None:
                min_ = min(p.value,min_)
                max_ = max(p.value,max_)
        if max_ < min_:
            #print b.__class__,'no values'
            for p in b.planets.values(): p.value = 0
            return
        if max_ == min_:
            #print b.__class__,'one value'
            for p in b.planets.values():
                if p.value != None: p.value = 100
                else: p.value = 0
            return
        for p in b.planets.values():
            if p.value != None:
                p.value = ((p.value-min_)*100/(max_-min_))
            else: p.value = 0
            
            
    def loop(self):
        self.frame += 1
        if (self.frame%self.speed) != 0: return
        
        #figure values based on sub-bots
        for p in self.planets.values():
            p.value = 0
        for w,b in self.bots:
            b.evaluate()
            self.normalize(b)
            for pid,p in self.planets.items():
                p.value += w*b.planets[pid].value
                
        self.normalize(self)

        #spread via div_sum
        for p in self.planets.values():
            p.my_value = p.value
        for p1 in self.planets.values():
            value = 0
            div = 0
            for p2,dist in p1.dists.items():
                value += p2.my_value / dist
                div += 1.0/dist
            p1.value = round((p1.my_value*2.0 + value/div)/3.0)
                
        #for p in self.planets.values():
            #self.level.planets[p.n].value = p.value
        #self.level.stat = 'value'
        #self.level.options.hide_stats = False
        
        p2s = [(p2.value,p2) for p2 in self.planets.values()]
        p2s.sort()
        value,p2 = p2s.pop()
        
        p1s = [(p1.dists[p2],p1) for p1 in self.planets.values() if (p1.user == self and p1.value < p2.value and p1.ships > (14/0.75))] 
        if not len(p1s): return
        p1s.sort()
        dist,p1 = p1s.pop()
        
        
        #print p1.value,p2.value,p1.value<p2.value

        ships = int(p1.ships*0.75)
        self.level.fleet(self,p1.item,p2.item,ships)
