import random
import galcon

class Finisher(galcon.Bot):
    def init(self):
        self.planets = {}
        for pid,p in self.level.planets.items():
            self.planets[pid] = galcon.Wrapper(p)
        
    def evaluate(self):
        for p in self.planets.values():
            p.value = None

        ships = {}
        for p in self.planets.values():
            if not isinstance(p.user,galcon.Neutral):
                if p.user.team not in ships: ships[p.user.team] = 0
                ships[p.user.team] += p.ships
        for f in self.level.fleets.values():
            if not isinstance(f.user,galcon.Neutral):
                if f.user.team not in ships: ships[f.user.team] = 0
                ships[f.user.team] += f.ships
            
        if self.team not in ships: return
        
        myships = ships[self.team]
        del ships[self.team]
        
        total = 0
        for v in ships.values(): total += v
        
        if myships < total*4: return
        
        #calculate the value of each planet
        for p in self.planets.values():
            if p.user.team != self.team and not isinstance(p.user,galcon.Neutral):
                p.value = p.production #+p.attack+p.defence
        
