import galcon
import gui
import dialog
import level

import bot5000
Bot5000 = bot5000.Bot5000
import combo
Combo = combo.Combo
import siege
Siege = siege.Siege
import copycat
Copycat = copycat.Copycat
import kamikaze
Kamikaze = kamikaze.Kamikaze
import raid
Raid = raid.Raid
import scavenger
Scavenger = scavenger.Scavenger
import greedy
Greedy = greedy.Greedy
import spread
Spread = spread.Spread
import defence
Defence = defence.Defence
import finisher
Finisher = finisher.Finisher
import rand
Rand = rand.Rand

def MySiege(): # bit easy
    return Combo([(100,Siege),(200,Finisher)])
def MyCopycat():
    return Combo([(100,Copycat),(200,Finisher)])
def MyKamikaze(): # bit easy
    return Combo([(100,Kamikaze),(200,Finisher)])
def MyRand():
    return Combo([(100,Rand),(200,Finisher)])
#def MyRaid():
    #return Combo([(100,Raid),(200,Finisher)])
def MyScavenger(): # bit hard
    return Combo([(100,Scavenger),(200,Finisher)])
def MyGreedy():
    return Combo([(100,Greedy),(100,Spread),(200,Finisher)])
def MyDefence(): # good play
    return Combo([(100,Spread),(100,Defence),(200,Finisher)])

mdata = [
    ('mission2','classic',
        'classic galcon mission, 1 on 1',
        [(0,21,None,None), (1,1,100,100),   (2,1,100,100,    Bot5000,[95,])],
        ),
    
    ('blah','siege',
        "-",
        [(0,21,None,None), (1,1,100,100),   (2,3,100,100,MySiege,[])],
        ),
    ('blah','copycat',
        "-",
        [(0,21,None,None), (1,1,100,100), (2,1,100,112,MyCopycat,[])],
        ),
    ('blah','kamikaze',
        "-",
        [(0,21,None,None), (1,1,100,100), (2,1,100,100,MyKamikaze,[])],
        ),
    ('blah','rand',
        "-",
        [(0,21,None,None), (1,1,100,100), (2,4,100,95,MyRand,[])],
        ),
    ('blah','scavenger',
        "-",
        [(0,21,None,None), (1,1,100,100), (2,2,100,60,MyScavenger,[])],
        ),
    ('blah','greedy',
        "-",
        [(0,21,None,None), (1,1,100,100), (2,2,100,75,MyGreedy,[])],
        ),
    ('blah','defence', # pretty well balanced
        "-",
        [(0,21,None,None), (1,1,100,100), (2,2,100,100,MyDefence,[])],
        ),

    ('mission4','massive',
        'for when you are in the mood for a gigantic war.',
        [(0,41,None,None), (1,1,100,100),   (2, 1,100,50,    Bot5000,[95,])],
        ),
    ('mission4','minions',
        'enemy encampents cover 1/3 of the galaxy',
        [(0,21,None,None), (1,1,100,100),   (2, 10,25,13,     Bot5000,[50,])],
        ),
    ('mission4','mega',
        '2 on 2, with mega planets',
        [(0,21,None,None), (1,2,200,200),   (2, 2,200,200,   Bot5000,[95,])],
        ),

    ('mission2','3 on 3',
        'its an even 3 on 3 match with more planets',
        [(0,31,None,None), (1,3,100,100),    (2,3,100,75,    Bot5000,[95,])],
        ),
    ('mission1','gang',
        'a 2 to 1 match against you',
        [(0,21,None,None), (1,1,100,100),    (2,2,100,55,     Bot5000,[95,])],
        ),
    ('mission1','goliath',
        'if you can beat goliath, you are the master',
        [(0,21,None,None), (1,1,100,100),    (2,1,200,60,    Bot5000,[95,])],
        ),
    ('mission4','herd',
        'your encampents cover 1/3 of the galaxy',
        [(0,21,None,None), (1,10,25,13),   (2, 1,100,100,     Bot5000,[95,])],
        ),
    ]
    
class PWidget(gui.Widget):
    def __init__(self,n,sz,**params):
        gui.Widget.__init__(self,**params)
        self.n = n
        self.size = sz
        self.style['width'],self.style['height'] = sz+20,sz+20
        
        
    def paint(self,s):
        sz = self.size + 8*('hover' in self.pseudo)
        pos = (s.get_width()/2,s.get_height()/2)
        r = sz/2
        s.planet(COLORS[self.n%len(COLORS)],pos,r,None,self.n)

        
import diffs

class MissionMenu(gui.App):
    def __init__(self,game,parent):
        self.game =game
        self.parent = parent
        self.next = None
        self.widget = None

    def init(self):
        galcon.misc_music_play('missions')
        f = gui.Form()
        bkgr = galcon.Bkgr()
        logo = galcon.misc_get_logo()
        z = 400
        logo = logo.scale((z,logo.get_height()*z/logo.get_width()))
        bkgr.blit(logo,((SW-z)/2,0))
        self.widget = t = gui.Table(background=bkgr)
        
        app = self
        

        t.tr()
        t.td(gui.Spacer(1,100))
        pad = 8

        g = gui.Group(name='diff',value=diffs.get_diff()) #self.game.cfg['diff'])
        def onchange():
            diffs.set_diff(g.value)
        g.onchange = onchange
        
        tt = gui.Table()
        
        tt.tr()
        self.form = f
        n = 0
        
        for v,spd,txt in diffs.DIFFS:
            tt.td(gui.Radio(g,value=v))
            tt.td(gui.Box(gui.Label(txt),style={'padding-left':pad,'padding-right':pad*3}))
            
            n += 1
            if n == 4:
                tt.tr()
                tt.td(gui.Spacer(4,4))
                tt.tr()
            
        t.tr()
        t.td(tt,colspan=4)

        t.tr(); t.td(gui.Spacer(pad*1,pad*1))
        
        my_t =t

        t = gui.Table()

        n = 0
        for name,title,desc,stats in mdata[:]:
            if (n%5) == 0:
                t.tr()

            tt = gui.Table(width=108)
            tt.tr()
            w = PWidget(n,32,style={'margin-top':pad/2})
            
            tt.td(w)
            w.onclick = self.pclick(stats)
            #w.connect(gui.CLICK,self.my_action,self.action_start,stats)


            tt.tr()
            tt.td(gui.Box(gui.Label(title),style={'margin-bottom':pad/2}))
            t.td(tt)


            n += 1

        missions = t

        t = my_t

        t.tr()
        t.td(gui.Spacer(pad*1,pad*1))

        t.tr()
        t.td(missions,colspan=4)

        t.tr()
        t.td(gui.Spacer(pad*2,pad*2))
        t.tr()
        w = gui.Button('Back to Main Menu')
        w.onclick = self.action_menu
        #w.connect(gui.CLICK,self.my_action,self.action_menu)
        t.td(gui.Box(w),colspan=4)
        
    def pclick(self,stats):
        def onclick():
            return self.action_start(stats)
        return onclick


    def action_menu(self):
        self.goto(self.parent)

    def action_start(self,stats):
        
        l = level.Level(self.game,stats,self)
        self.goto(l)

