import random
import galcon

class Spread(galcon.Bot):
    def init(self):
        self.planets = {}
        for pid,p in self.level.planets.items():
            self.planets[pid] = galcon.Wrapper(p)
            
        #calculate distances between planets
        for p1 in self.planets.values():
            p1.dists = {}
            for p2 in self.planets.values():
                if p1 == p2: continue
                dx,dy = p2.rect.centerx-p1.rect.centerx,p2.rect.centery-p1.rect.centery
                p1.dists[p2] = (dx*dx+dy*dy)**0.5
            
    def evaluate(self):
        
        p2s = [p for p in self.planets.values() if p.user.team == self.team]
        
        #calculating nearby ships
        for p1 in self.planets.values():
            p1.value = None
            if p1.user.team == self.team: continue
            p1.value = 0
            for p2 in p2s:
                p1.value -= p1.dists[p2]
