## Title: Options
## Author: Phil Hassey
## License: Public Domain
## Description: Mods Example: A mission with fun options 
## See main.py, to learn how to build a game options menu.

import galcon
import gui

import level

def build_app(game):
    pad = 16
    
    t = gui.Table()
    box = gui.Box(t,width=SW,height=SH,background=galcon.Bkgr())
    app = gui.App(game,box,False)
    
    t.tr()
    t.td(gui.Box(gui.Label('Game Options',style={'font':galcon.Font(32)}),style={'margin-bottom':pad}),colspan=2)
    
    f = gui.Form()
    
    t.tr()
    t.td(gui.Label('Planets'))
    t.td(gui.Slider('planets',10,65,value=23))
    t.tr()
    t.td(gui.Label('Homes'))
    t.td(gui.Slider('homes',1,3,value=1))
    t.tr()
    t.td(gui.Label('Production'))
    t.td(gui.Slider('production',15,200,value=100))
    t.tr()
    t.td(gui.Label('Ships'))
    t.td(gui.Slider('ships',15,200,value=100))
    t.tr()
    t.td(gui.Label('Bots'))
    t.td(gui.Slider('bots',1,5,value=1))
    
    t.tr()
    t.td(gui.Label('** Color'))
    ##
    tt = gui.Table()
    g = gui.Group('color')
    tt.tr()
    tt.td(gui.Radio(g,(255,0,0))); tt.td(gui.Label('Red'))
    tt.td(gui.Radio(g,(0,255,0))); tt.td(gui.Label('Green'))
    tt.td(gui.Radio(g,(0,0,255))); tt.td(gui.Label('Blue'))
    ##
    t.td(tt)
    
    t.tr()
    t.td(gui.Label('** Vortex Mode'))
    t.td(gui.Box(gui.Checkbox('vortex'),align=-1))
    
    t.tr()
    t.td(gui.Label('** Name'))
    t.td(gui.Input('name'))

    t.tr()
    w = gui.Button('Play Galcon!')
    t.td(gui.Box(w,style={'margin-top':pad}),colspan=2)
    def start():
        r = {}
        for k,v in f.items(): r[k] = v.value
        l = level.Level(game,r,app)
        app.goto(l)
    w.onclick = start
    
    t.tr()
    t.td(gui.Box(gui.Label('** this option has no effect'),style={'margin-top':pad}),colspan=2)
    
    return app


class Game:
    pass
    
def main():
    g = Game()
    g.font = galcon.Font(20)
    #l = level.Level(g,False)
    #return l
    r = build_app(g)
    return r
