## Title: bot.py
## Author: Phil Hassey
## License: Public Domain
## Description: Just a simple bot.  Feel free to do whatever with it.

import galcon
import math
import random

class Bot(galcon.Bot):
    def __init__(self,level):
        self.level = level
        
    def init(self):
        self.frame = random.randrange(0,FPS)
        
    def loop(self):
        self.frame += 1
        if (self.frame%galcon.FPS) != 0: return
        
        from_ = None
        for p in self.level.planets.values():
            if p.user != self: continue
            if from_ and p.ships < from_.ships: continue
            from_ = p
        if from_ == None: return
        
        to = None
        value = -1000
        for p in self.level.planets.values():
            if p.user.team == self.team: continue
            dist = math.hypot(p.pos[0]-from_.pos[0],p.pos[1]-from_.pos[1])
            v = -p.ships + p.production - (dist / 5)
            if to and v < value: continue
            to,value = p,v
        if to == None: return
        
        self.level.fleet(self,from_,to,from_.ships*65/100)
